SET request = json_object(
    'method', 'POST',
    'url', 'https://shandan.one/hash',
    'headers', json_object(),
    'body', json_object(
        'data', $content,
        'person', $tool
    )
);
SET hash = sqlpage.fetch($request);
SET fallback = 'https://shandan.one/upload/' || sqlpage.url_encode($hash);
SET request = json_object(
    'method', 'POST',
    'url', 'https://shandan.one/qr',
    'headers', json_object(),
    'body', json_object(
        'data', $content,
        'fallback', $fallback
    )
);
SET qr = sqlpage.fetch($request);
INSERT INTO upload (hash, content, name, mime, qr, created)
VALUES ($hash, $content, $file_name, $mime_type, $qr, CURRENT_TIMESTAMP)
ON CONFLICT DO
UPDATE SET
  content = excluded.content,
  name = excluded.name,
  mime = excluded.mime,
  created = excluded.created,
  qr = excluded.qr
WHERE excluded.created > upload.created;
SELECT 'dynamic' AS component, sqlpage.run_sql('sqlpage/link.sql') AS properties;
